<?php
/*
 *	Author	 :		Lucas Baltes
 *					$Author: lhb $
 *
 *  Version 2.0 by Miguel Angelo Rozsas (miguel@rozsas.xx.nom.br)
 *
 *	Copyright:		Lucas Baltes < lucas at thebobo com >
 *
 *	Date	 :		$Date: $
 *	Rev      :		$Revision: $
 *
 *	Purpose	 :		Display and index of collected monthly stats.
 *
 */

require_once ('globals.php');
require('connect.php');

# associate k (suffix=2^k, k=n.10, n=1,2,3...) to it's short/long multiplier name.
$short_suffix= array('1' => '',
						 '10' => 'KB',
						 '20' => 'MB',
						 '30' => 'GB',
						 '40' => 'TB',
						 '50' => 'PB',
						 '60' => 'EB');
						 
$long_suffix= array('1' => '',
						 '10' => 'Kilo',
						 '20' => 'Mega',
						 '30' => 'Giga',
						 '40' => 'Tera',
						 '50' => 'Peta', 
						 '60' => 'Exa');	
						 
#
# get the user choices
#
if (isset($_REQUEST['view']) && $_REQUEST['view'] != '') {
	$view= $_REQUEST['view'];
	$sel_if= ($_REQUEST['sel_if']=="default")? DEFAULT_IF: $_REQUEST['sel_if'];
	$sel_year= ($_REQUEST['sel_year']=="current")? CURRENT_YEAR: $_REQUEST['sel_year'];
	$sel_month= ($_REQUEST['sel_month']=="current")? CURRENT_MONTH: $_REQUEST['sel_month'];
	$sel_day= ($_REQUEST['sel_day']=="current")? CURRENT_DAY: $_REQUEST['sel_day'];
} else {
	$view= DEFAULT_VIEW;
	$sel_if= DEFAULT_IF;
	$sel_year= CURRENT_YEAR;
	$sel_month= CURRENT_MONTH;
	$sel_day= CURRENT_DAY;
}

# 
# if any values are default/current/0, change it to DEFAULT_WHATEVER
#
if ($sel_if=="default") $sel_if= DEFAULT_IF;
if ($sel_year=="current") $sel_year= CURRENT_YEAR;
if ($sel_month==0) $sel_month= CURRENT_MONTH;
if ($sel_day==0) $sel_day= CURRENT_DAY;

#
# set some variables view-dependents
#
switch ($view)
{
	case "year":
		$min_i= 1;
		$max_i= 12; # max_i is an upper limit in the fill the blanks below.
		$query = "select month(dts) as idx, sum(rx) as rx, sum(tx) as tx " .
			" FROM " . TABLE  .
			" WHERE if_name = '$sel_if' " .
			" AND year(dts) = '$sel_year' " .
			" GROUP BY idx " . 
			" ORDER BY idx ASC";
		$prev="index.php?sel_if=$sel_if&amp;sel_year=" . (CURRENT_YEAR-1) . "&amp;view=year";
		$next="index.php?sel_if=$sel_if&amp;sel_year=" . (CURRENT_YEAR+1) . "&amp;view=year";
		break;
		
	case "month":
		$min_i= 1;
		$max_i= get_days_in_month($sel_year,$sel_month);
		$query = "SELECT dayofmonth(dts) as idx, sum(tx) as tx, sum(rx) as rx" .
			" from " . TABLE .
			" where year(dts) = '$sel_year' " . 
			" AND month(dts) = '$sel_month' " . 
			" AND if_name = '$sel_if' " .
			" GROUP BY idx " .
			" ORDER BY idx ASC";
		$y= date('Y', mktime(0, 0, 0, $sel_month - 1, 1, $sel_year));
		$m= date('n', mktime(0, 0, 0, $sel_month - 1, 1, $sel_year));
		$prev="index.php?sel_if=$sel_if&amp;sel_year=$y&amp;sel_month=$m&amp;view=month";
		$y= date('Y', mktime(0, 0, 0, $sel_month + 1, 1, $sel_year));
		$m= date('n', mktime(0, 0, 0, $sel_month + 1, 1, $sel_year));
		$next="index.php?sel_if=$sel_if&amp;sel_year=$y&amp;sel_month=$m&amp;view=month";
		break;
		
	case "day":
		$min_i= 0;
		$max_i= 23;
		$query = "SELECT hour(dts) as idx, sum(tx) as tx, sum(rx) as rx " .
			" from " . TABLE .
			" where year(dts) = '$sel_year' " . 
			" AND month(dts) = '$sel_month' " . 
			" AND dayofmonth(dts) = '$sel_day' " . 
			" AND if_name = '$sel_if' " .
			" GROUP BY idx " .
			" ORDER BY idx ASC";
		$y= date('Y', mktime(0, 0, 0, $sel_month, $sel_day-1, $sel_year));
		$m= date('n', mktime(0, 0, 0, $sel_month, $sel_day-1, $sel_year));
		$d= date('j', mktime(0, 0, 0, $sel_month, $sel_day-1, $sel_year));
		$prev="index.php?sel_if=$sel_if&amp;sel_year=$y&amp;sel_month=$m&amp;sel_day=$d&amp;view=day";
		$y= date('Y', mktime(0, 0, 0, $sel_month, $sel_day+1, $sel_year));
		$m= date('n', mktime(0, 0, 0, $sel_month, $sel_day+1, $sel_year));
		$d= date('j', mktime(0, 0, 0, $sel_month, $sel_day+1, $sel_year));
		$next="index.php?sel_if=$sel_if&amp;sel_year=$y&amp;sel_month=$m&amp;sel_day=$d&amp;view=day";
		break;
		
	default:
		$min_i= 1;
		$max_i= 12;
		$view= "year";
		$prev="index.php?sel_if=$sel_if&amp;sel_year=" . (CURRENT_YEAR-1) . "&amp;view=year";
		$next="index.php?sel_if=$sel_if&amp;sel_year=" . (CURRENT_YEAR+1) . "&amp;view=year";
		break;
}

#
# Get data from database
#
$result = $db->query($query);

#
# Extract data from query to a temporary dbdata array.
# Collect some statistics too. (max, min, mean, etc)
#
$max_tx= $max_rx= $sum_tx= $sum_rx= $sum_tx2= $sum_rx2= $max_io= 0;
$min_tx= $min_rx= $min_io= pow(2,32); # just a big number, the biggest one.

$n= $result->numRows();
if (!DB::isError($result)) {
	if ($n>0) {
		while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$idx= $row['idx'];
			# find the max tx and rx in this set
			if ($row['tx'] > $max_tx) {
				$max_tx= $row['tx'];
				$idx_max_tx= $idx;
			}
			if ($row['rx'] > $max_rx) {
				$max_rx= $row['rx'];
				$idx_max_rx= $idx;
			}
			# find the max (tx+rx) in this set
			if (($row['tx']+$row['rx']) > $max_io) {
				$max_io= $row['tx']+$row['rx'];
			}

			# find the min non-zero tx and rx in this set
      if ($row['tx']!=0) {
			  if ($row['tx'] < $min_tx) {
				  $min_tx= $row['tx'];
				  $idx_min_tx= $idx;
        }
			}

      if ($row['rx']!=0) {
        if ($row['rx'] < $min_rx) {
          $min_rx= $row['rx'];
          $idx_min_rx= $idx;
        }
      }
			# find the min (tx+rx) in this set
      if (($row['tx']+$row['rx']) != 0) {
        if (($row['tx']+$row['rx']) < $min_io) {
          $min_io= $row['tx']+$row['rx'];
        }
      }

			
			# theses are to calculate mean(x) and sdev(x)
			# sum of x
			$sum_tx+= $row['tx'];
			$sum_rx+= $row['rx'];
			# sum of x^2
			$sum_tx2+= $row['tx']*$row['tx'];
			$sum_rx2+= $row['rx']*$row['rx'];

      # compute median
      $datatx[]=$row['tx'];
      $datarx[]=$row['rx'];
			
			# fill a temporary array dbdata
			$dbdata[$idx]= array (
				"idx" => $idx,
				"short_idx" => short_idx ($idx, $view),
				"long_idx" => long_idx ($idx, $view),
				"rx" => $row['rx'], 
				"tx" => $row['tx'],
				"total" => $row['rx']+$row['tx'],
				"na" => 0); # na=0 indicates that exists data from DB for this index.
		}
	}
} else {
	print ("Error: " . mysql_error() . "\n");
	$errors .= "db error.<br>" . "<p>" . mysql_error () . "</p>";
	$smarty->assign("errors", $errors);
}

#
# Create max throughput string and links. Used in Summary table.
#
if ($n>0) {
	switch ($view) 
	{
		case "year":
			$str_idx_max_tx=  "in " . date('F', mktime(0, 0, 0, $idx_max_tx, 1, 2000));
			$str_idx_max_rx=  "in " . date('F', mktime(0, 0, 0, $idx_max_rx, 1, 2000));
			$str_idx_min_tx=  "in " . date('F', mktime(0, 0, 0, $idx_min_tx, 1, 2000));
			$str_idx_min_rx=  "in " . date('F', mktime(0, 0, 0, $idx_min_rx, 1, 2000));
			
			break;
			
		case "month":
			$str_idx_max_tx=  "on the " . date('jS', mktime(0, 0, 0, 1, $idx_max_tx, 2000));
			$str_idx_max_rx=  "on the " . date('jS', mktime(0, 0, 0, 1, $idx_max_rx, 2000));
			$str_idx_min_tx=  "on the " . date('jS', mktime(0, 0, 0, 1, $idx_min_tx, 2000));
			$str_idx_min_rx=  "on the " . date('jS', mktime(0, 0, 0, 1, $idx_min_rx, 2000));
			break;
			
		case "day":
			$str_idx_max_tx=  "at " . date('H', mktime($idx_max_tx, 0, 0, 1, 1, 2000)) . "h";
			$str_idx_max_rx=  "at " . date('H', mktime($idx_max_rx, 0, 0, 1, 1, 2000)) . "h";
			$str_idx_min_tx=  "at " . date('H', mktime($idx_min_tx, 0, 0, 1, 1, 2000)) . "h";
			$str_idx_min_rx=  "at " . date('H', mktime($idx_min_rx, 0, 0, 1, 1, 2000)) . "h";
			break;
			
		default:
			$str_idx_max_tx=  "on " . date('F', mktime(0, 0, 0, $idx_max_tx, 1, 2000));
			$str_idx_max_rx=  "on " . date('F', mktime(0, 0, 0, $idx_max_rx, 1, 2000));
			$str_idx_min_tx=  "on " . date('F', mktime(0, 0, 0, $idx_min_tx, 1, 2000));
			$str_idx_min_rx=  "on " . date('F', mktime(0, 0, 0, $idx_min_rx, 1, 2000));
			break;
	}
}

#
# Compute mean and sdev
#
if ($n>0) {
	$mean_tx= $sum_tx/$n;
	$mean_rx= $sum_rx/$n;
	$sdev_tx= sqrt($sum_tx2/$n - pow($sum_tx/$n, 2));
	$sdev_rx= sqrt($sum_rx2/$n - pow($sum_rx/$n, 2));
} else {
	$mean_tx= "na";
	$mean_rx= "na";
	$sdev_tx= "na";
	$sdev_rx= "na";
}

#
# Compute median
#
if (is_array($datatx)) sort($datatx);
if (is_array($datarx)) sort($datarx);

if ($n>0) {
  $i= count($datatx);
  $pos= (integer) $i/2;
  if ($i%2 == 0) {
    # even
    $median['tx']= ($datatx[$pos-1] + $datatx[$pos])/2;
  } else {
    # odd
    $median['tx']= $datatx[$pos];
  }

  $i= count($datarx);
  $pos= (integer) $i/2;
  if ($i%2 == 0) {
    # even
    $median['rx']= ($datarx[$pos-1] + $datarx[$pos])/2;
  } else {
    # odd
    $median['rx']= $datarx[$pos];
  }
} else {
  $median['tx']= 'na';
  $median['rx']= 'na';
}



#
# calcule the best scale
if ($n>0) {
  # k is a index to $suffix to get the proper suffix string and compute scale.
  $k= best_scale ($view);
	$best_short_suffix= $short_suffix[$k];
	$best_long_suffix= $long_suffix[$k];
	$scale= pow(2, $k); # 1 <= m/scale < 1000

  # it's used to compute hscale and dependends on max_tx and max_rx.
  $m= max($max_tx, $max_rx);
} else {
	$m= 0;
	$scale= 1;
	$best_short_suffix= "";
	$best_long_suffix= "";
}

#
# Create a ordered data from dbdata
# and fill the positions where dbdata[idx] is undefined.
# This is necessary because the dbdata may have 'blanks´.
# Scale the values rx, tx and total, too.
# 
for ($i=$min_i; $i<=$max_i; $i++) {
	if (! isset ($dbdata[$i])) {
		$dbdata[$i]= array(
			"idx" => $i,
			"short_idx" => short_idx ($i, $view),
			"long_idx" => long_idx ($i, $view),
			"na" => 1);					# na=1 indicates that does not exist data for this index.
	}
	$dbdata[$i]['rx'] /= $scale;
	$dbdata[$i]['tx'] /= $scale;
	$dbdata[$i]['total'] /= $scale;
	# data will be iterated by smarty function foreach on associated template.
	$data[]= $dbdata[$i];
}
$smarty->assign("data", $data);

#
# Create a summary for this data
# mean, sdev, total, current date and time, versionm, etc.
#
$summary= array (
	"mean_tx" => $mean_tx/$scale,
	"mean_rx" => $mean_rx/$scale,
	"sdev_tx" => $sdev_tx/$scale,
	"sdev_rx" => $sdev_rx/$scale,
  "median_tx" => $median['tx']/$scale,
  "median_rx" => $median['rx']/$scale,
	"total" => ($sum_tx+$sum_rx)/$scale,
	"total_tx" => $sum_tx/$scale,
	"total_rx" => $sum_rx/$scale,
	"max_tx" => $max_tx/$scale,
	"max_rx" => $max_rx/$scale,
	"str_idx_max_tx" => $str_idx_max_tx,
	"str_idx_max_rx" => $str_idx_max_rx,
	"idx_max_tx" => $idx_max_tx,
	"idx_max_rx" => $idx_max_rx,
	"min_tx" => $min_tx/$scale,
	"min_rx" => $min_rx/$scale,
	"str_idx_min_tx" => $str_idx_min_tx,
	"str_idx_min_rx" => $str_idx_min_rx,
	"idx_min_tx" => $idx_min_tx,
	"idx_min_rx" => $idx_min_rx
	);
	
$smarty->assign ("summary", $summary);

#
# create a scale resource array
#
$scale= array (
	"vscale" => $max_io/$scale/100, # % filled in the free space of cell
	"hscale" => $m/$scale/100, # % filled in the free space of cell
	"short_suffix" => $best_short_suffix,
	"long_suffix" => $best_long_suffix);
$smarty->assign ("scale", $scale);


#
# create a miscelanea resource array
#
$misc= array (
	"view" => $view,
	"cur_date" => date('Y-m-d'),
	"cur_time" => date('h:m:s T'),
	"cur_day" => CURRENT_DAY, # numeric
	"cur_month" => CURRENT_MONTH, # numeric
	"cur_year" => CURRENT_YEAR, # numeric
	"sel_day" => $sel_day,
	"sel_month" => $sel_month,
	"sel_year" => $sel_year,
	"sel_if" => $sel_if,
	"long_sel_if" => $if_array[$sel_if],
	"short_sel_month" => date('M', mktime(0, 0, 0, $sel_month, 1, 2000)),
	"long_sel_month" => date('F', mktime(0, 0, 0, $sel_month, 1, 2000)),
	"na" => ($n)? 0: 1,
	"prev" => $prev,
	"next" => $next,
	"version" => VERSION);
$smarty->assign ("misc", $misc);

#
# do it!
#
$smarty->display("index.tpl");
?>
